<?php
require_once('util.php');

// ѿν
$isbn = '';
$title = '';
$price = '';
$publish = '';
$url = '';
$cnt = 0;
$db = null;
$result = null;
$ErrorMsg = '';

// μ
if ( isset( $_POST['isbn'], $_POST['title'], $_POST['price'], $_POST['publish'], $_POST['url'] ) ) {
	$isbn = $_POST['isbn'];
	$title = $_POST['title'];
	$price = $_POST['price'];
	$publish = $_POST['publish'];
	$url = $_POST['url'];
}

// ISBNΥå(̤ϡå)
if ( mb_strlen(trim($isbn)) == 0 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR001 . '<br />';
} elseif ( mb_strlen(trim($isbn)) > 50 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR002 . '<br />';
}
// ISBN¸ߥå
if ( $db = sqlite_open(DSN, 0666, $sqliteerror) ) {
	$isbn = sqlite_escape_string(trim($isbn));
	$sql = "SELECT count(*) FROM book WHERE isbn = '$isbn'";
	$result = sqlite_query($db, $sql);
	if ( !$result ) {
	  echo DB_CONNECT_ERR002 . '<br />';
	  exit();
	}
	$cnt = intval(sqlite_fetch_single($result));
	if ( $cnt == 0 ) {
		$ErrorMsg .= '' . $isbn . 'פ' . BOOK_UPDATE_ERR003 . '<br />';
	}
	sqlite_close($db);
} else {
	die($sqliteerror);
}

// ȥΥå(̤ϡå)
if ( mb_strlen(trim($title)) == 0 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR004 . '<br />';
} elseif ( mb_strlen(trim($title)) > 100 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR005 . '<br />';
}

// ʤΥå
if ( mb_strlen(trim($price)) == 0 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR006 . '<br />';
}
if ( !is_numeric($price) ) {
	$ErrorMsg .= BOOK_UPDATE_ERR007 . '<br />';
}
if ( $price < 0 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR008 . '<br />';
}

if ( mb_strlen(trim($publish)) == 0 ) {
	$ErrorMsg .= BOOK_UPDATE_ERR008 . '<br />';
}
if ( !is_numeric($publish) ) {
	$ErrorMsg .= BOOK_UPDATE_ERR010 . '<br />';
}

// URLηå
if ( mb_strlen(trim($url)) > 0 ) {
	if ( mb_strlen(trim($url)) > 200 ) {
		$ErrorMsg .= BOOK_UPDATE_ERR011 . '<br />';
	} elseif ( is_url($url) == FALSE ) {
		$ErrorMsg .= BOOK_UPDATE_ERR012 . '<br />';
	}
}

if ( mb_strlen(trim($ErrorMsg)) > 0 ) {
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">';
	echo '<head>';
	echo '<title></title>';
	echo '<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP" />';
	echo '<meta http-equiv="Content-Style-Type" content="text/css" />';
	echo '<link rel="stylesheet" type="text/css" href="../style.css" />';
	echo '</head>';
	echo '<body>';
	echo $ErrorMsg;
	echo '<form action="book_update.php?isbn=' . rawurlencode(htmlspecialchars($isbn, ENT_QUOTES, 'EUC-JP')) . '" method="post">';
	echo '<input id="title" name="title" type="hidden" value="' . htmlspecialchars($title, ENT_QUOTES, 'EUC-JP') . '" />';
	echo '<input id="price" name="price" type="hidden" value="' . htmlspecialchars($price, ENT_QUOTES, 'EUC-JP') . '" />';
	echo '<input id="publish" name="publish" type="hidden" value="' . htmlspecialchars($publish, ENT_QUOTES, 'EUC-JP') . '" />';
	echo '<input id="url" name="url" type="hidden" value="' . htmlspecialchars($url, ENT_QUOTES, 'EUC-JP') . '" />';
	echo '<br />';
	echo '<input type="submit" id="back" name="back" value="" />';
	echo '</form>';
	echo '</body>';
	echo '</html>';
	exit();
}

// 
if ( $db = sqlite_open(DSN, 0666, $sqliteerror) ) {
	sqlite_query("BEGIN;", $db);
	$isbn = sqlite_escape_string(trim($isbn));
	$title = sqlite_escape_string(trim($title));
	$price = sqlite_escape_string(intval($price));
	$publish = sqlite_escape_string(intval($publish));
	$url = sqlite_escape_string(trim($url));
	$sql = "UPDATE book SET " . 
				"title = '$title', " .
				"price = $price, " . 
				"publish_id = $publish, " . 
				"url = '$url' " . 
			"WHERE " . 
				"isbn = '$isbn'";
	$result = sqlite_query($db, $sql);
	if ($result) {
		sqlite_query("COMMIT;", $db);
	} else {
		sqlite_query("ROLLBACK;", $db);
	}
	sqlite_close($db);
} else {
	die($sqliteerror);
}

header('Location: book_list.php');
?>
